﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Otus.Teaching.PromoCodeFactory.DataAccess;

namespace Otus.Teaching.PromoCodeFactory.DataAccess.Migrations
{
    [DbContext(typeof(DatabaseContext))]
    partial class DatabaseContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.32");

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<int>("AppliedPromocodesCount")
                        .HasColumnType("INTEGER");

                    b.Property<string>("Email")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<Guid>("EmployeeOfPromocodeId")
                        .HasColumnType("TEXT");

                    b.Property<string>("FirstName")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<string>("LastName")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.HasKey("Id");

                    b.HasIndex("EmployeeOfPromocodeId")
                        .IsUnique();

                    b.ToTable("Employees");

                    b.HasData(
                        new
                        {
                            Id = new Guid("fde35f0b-3c10-4520-a489-a45841b7c96f"),
                            AppliedPromocodesCount = 5,
                            Email = "owner@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("6f4953c1-c6b8-4dcc-bfcf-50c8c5a1c4ae"),
                            FirstName = "Иван",
                            LastName = "Сергеев"
                        },
                        new
                        {
                            Id = new Guid("7650bdaf-875f-4b58-a6cf-e6a9fd531435"),
                            AppliedPromocodesCount = 10,
                            Email = "andreev@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("733d3c4a-8419-4355-a127-a9bf10b46e7a"),
                            FirstName = "Петр",
                            LastName = "Андреев"
                        },
                        new
                        {
                            Id = new Guid("2cd26ca8-91fc-439a-a234-c28c5f4c455a"),
                            AppliedPromocodesCount = 10,
                            Email = "andreev@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("edeedf21-ffe3-4f72-90b0-c1dca969f673"),
                            FirstName = "Петр",
                            LastName = "Андреев"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Name")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<Guid>("RoleOfEmployeeId")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("RoleOfEmployeeId")
                        .IsUnique();

                    b.ToTable("Roles");

                    b.HasData(
                        new
                        {
                            Id = new Guid("53729686-a368-4eeb-8bfa-cc69b6050d02"),
                            Name = "Admin",
                            RoleOfEmployeeId = new Guid("fde35f0b-3c10-4520-a489-a45841b7c96f")
                        },
                        new
                        {
                            Id = new Guid("b0ae7aac-5493-45cd-ad16-87426a5e7665"),
                            Name = "PartnerManager",
                            RoleOfEmployeeId = new Guid("7650bdaf-875f-4b58-a6cf-e6a9fd531435")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Email")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<string>("FirstName")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<string>("LastName")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.HasKey("Id");

                    b.ToTable("Customers");

                    b.HasData(
                        new
                        {
                            Id = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            Email = "ivan_ivanov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Иванов"
                        },
                        new
                        {
                            Id = new Guid("b782b026-f13d-4c9e-a601-132252ed4497"),
                            Email = "ivan_petrov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Петров"
                        },
                        new
                        {
                            Id = new Guid("3b6fe240-2695-4cb2-b63d-135980f8d8f4"),
                            Email = "ivan_sidorov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Сидоров"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.CustomerPreference", b =>
                {
                    b.Property<Guid>("CustomerId")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("PreferenceId")
                        .HasColumnType("TEXT");

                    b.HasKey("CustomerId", "PreferenceId");

                    b.HasIndex("PreferenceId");

                    b.ToTable("CustomerPreferences");

                    b.HasData(
                        new
                        {
                            CustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            PreferenceId = new Guid("11be81a8-242b-43da-a2b4-b638f939e819")
                        },
                        new
                        {
                            CustomerId = new Guid("b782b026-f13d-4c9e-a601-132252ed4497"),
                            PreferenceId = new Guid("41e47e28-9e63-4f26-b638-4df9020046b8")
                        },
                        new
                        {
                            CustomerId = new Guid("3b6fe240-2695-4cb2-b63d-135980f8d8f4"),
                            PreferenceId = new Guid("5e851ab7-a678-468a-a80f-eb63e12ddef9")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Name")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<Guid>("PreferenceOfPromocodeId")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("PreferenceOfPromocodeId")
                        .IsUnique();

                    b.ToTable("Preferences");

                    b.HasData(
                        new
                        {
                            Id = new Guid("11be81a8-242b-43da-a2b4-b638f939e819"),
                            Name = "Театр",
                            PreferenceOfPromocodeId = new Guid("6f4953c1-c6b8-4dcc-bfcf-50c8c5a1c4ae")
                        },
                        new
                        {
                            Id = new Guid("41e47e28-9e63-4f26-b638-4df9020046b8"),
                            Name = "Семья",
                            PreferenceOfPromocodeId = new Guid("733d3c4a-8419-4355-a127-a9bf10b46e7a")
                        },
                        new
                        {
                            Id = new Guid("5e851ab7-a678-468a-a80f-eb63e12ddef9"),
                            Name = "Дети",
                            PreferenceOfPromocodeId = new Guid("edeedf21-ffe3-4f72-90b0-c1dca969f673")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("BeginDate")
                        .HasColumnType("TEXT");

                    b.Property<string>("Code")
                        .HasColumnType("TEXT")
                        .HasMaxLength(60);

                    b.Property<Guid>("CurrentCustomerId")
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("EndDate")
                        .HasColumnType("TEXT");

                    b.Property<string>("PartnerName")
                        .HasColumnType("TEXT")
                        .HasMaxLength(100);

                    b.Property<string>("ServiceInfo")
                        .HasColumnType("TEXT")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("CurrentCustomerId");

                    b.ToTable("Promocodes");

                    b.HasData(
                        new
                        {
                            Id = new Guid("6f4953c1-c6b8-4dcc-bfcf-50c8c5a1c4ae"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code1",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName1",
                            ServiceInfo = "ServiceInfo1"
                        },
                        new
                        {
                            Id = new Guid("733d3c4a-8419-4355-a127-a9bf10b46e7a"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code2",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName2",
                            ServiceInfo = "ServiceInfo2"
                        },
                        new
                        {
                            Id = new Guid("edeedf21-ffe3-4f72-90b0-c1dca969f673"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code3",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName3",
                            ServiceInfo = "ServiceInfo3"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", "Promocode")
                        .WithOne("PartnerManager")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", "EmployeeOfPromocodeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", "Employee")
                        .WithOne("Role")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", "RoleOfEmployeeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.CustomerPreference", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", "Customer")
                        .WithMany("CustomerPreferences")
                        .HasForeignKey("CustomerId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", "Preference")
                        .WithMany("CustomerPreferences")
                        .HasForeignKey("PreferenceId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", "Promocode")
                        .WithOne("Preference")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", "PreferenceOfPromocodeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", "Customer")
                        .WithMany("Promocodes")
                        .HasForeignKey("CurrentCustomerId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
